package io.gitlab.jfronny.resclone;

import io.gitlab.jfronny.commons.serialize.gson.api.v1.GsonHolders;
import io.gitlab.jfronny.resclone.api.RescloneApi;
import io.gitlab.jfronny.resclone.api.RescloneEntry;
import io.gitlab.jfronny.resclone.fetchers.*;
import io.gitlab.jfronny.resclone.processors.PruneVanillaProcessor;
import io.gitlab.jfronny.resclone.util.config.*;
import net.fabricmc.api.EnvType;
import net.fabricmc.loader.api.FabricLoader;

public class RescloneEntryDefault implements RescloneEntry {
    @Override
    public void init(RescloneApi api) {
        GsonHolders.registerTypeAdapter(RescloneConfig.class, new RescloneConfigTypeAdapter());
        api.addFetcher(new BasicFileFetcher());
        api.addFetcher(new GitHubFetcher());
        api.addFetcher(new CurseforgeFetcher());
        api.addFetcher(new ModrinthFetcher());
        if (FabricLoader.getInstance().getEnvironmentType() == EnvType.CLIENT)
            api.addProcessor(new PruneVanillaProcessor());
        ConfigLoader.load(api);
    }
}
